Index: /trunk/src/slib.c
===================================================================
--- /trunk/src/slib.c	(revision 584)
+++ /trunk/src/slib.c	(revision 1)
@@ -1,17 +1,4 @@
 #include "config_xor.h"
 
-#if defined(HAVE_POSIX_FADVISE) && defined(HAVE_MINCORE)
-
-#if defined(__sun) || defined(__sun__) || defined(sun)
-#define _XOPEN_SOURCE 500
-#else
-#define _XOPEN_SOURCE 600
-#endif
-
-#if defined(__GNUC__)
-#define _DEFAULT_SOURCE
-#endif
-#define _BSD_SOURCE
-#endif
 
 #include <stdio.h>
@@ -19,24 +6,22 @@
 #include <stdarg.h>
 #include <string.h>
-#include <limits.h>
-#ifdef HAVE_STDINT_H
-/* for SIZE_MAX */
-#include <stdint.h>
-#endif
-
+
+
+#include <unistd.h>
+#include <sys/stat.h>
 #include <sys/types.h>
-#include <sys/stat.h>
-#include <unistd.h>
 #include <fcntl.h>
 #include <signal.h>
 
-#if defined(HAVE_POSIX_FADVISE) && defined(HAVE_MINCORE)
-#include <sys/mman.h>
-#endif
-
+#if TIME_WITH_SYS_TIME
+#include <sys/time.h>
+#include <time.h>
+#else
 #if HAVE_SYS_TIME_H
 #include <sys/time.h>
-#endif
+#else
 #include <time.h>
+#endif
+#endif
 
 #ifdef HAVE_MEMORY_H
@@ -60,12 +45,8 @@
 #endif
 
-#define SH_REAL_SET
-
 #include "slib.h"
 #include "sh_calls.h"
 #define SH_NEED_PWD_GRP 1
 #include "sh_static.h"
-#include "sh_pthread.h"
-#include "sh_string.h"
 
 #undef  FIL__
@@ -117,12 +98,14 @@
 static FILE * trace_fp     = NULL;
 
-int  sl_trace_use (const char * dummy)
-{
-  (void) dummy;
-  slib_do_trace = 1;
+int  sl_trace_use (char * dummy)
+{
+  if (dummy)
+    slib_do_trace = 1;
+  else
+    slib_do_trace = 1;
   return 0;
 }
 
-int  sl_trace_file (const char * str)
+int  sl_trace_file (char * str)
 {
   if (!str)
@@ -134,5 +117,5 @@
 }
 
-FILE * sl_tracefile_open(const char * file, const char * mode)
+FILE * sl_tracefile_open(char * file, char * mode)
 {
   FILE * xp = NULL;
@@ -143,5 +126,5 @@
 }
 
-void sl_trace_in(const char * str, const char * file, int line)
+void sl_trace_in(char * str, char * file, int line)
 {
   int    i;
@@ -165,5 +148,4 @@
 	  fprintf(trace_fp, "[%2d] %s \t - File %c%s%c at line %d\n", 
 		 trace_level, str, 0x22, file, 0x22, line);
-	  fflush(trace_fp);
 	}
       else
@@ -176,5 +158,5 @@
 }
 
-void sl_trace_out(const char * str, const char * file, int line)
+void sl_trace_out(char * str, char * file, int line)
 {
   int    i;
@@ -201,5 +183,4 @@
 	  fprintf(trace_fp, _("[%2d] %s \t - File %c%s%c at line %d\n"), 
 		 trace_level, str, 0x22, file, 0x22, line);
-	  fflush(trace_fp);
 	}
       else
@@ -211,5 +192,5 @@
 }
 
-extern int sh_log_console (const char * msg);
+extern int sh_log_console (char * msg);
 
 static int dlogActive = 0;
@@ -226,5 +207,5 @@
  *      = 3 backtrace
  */
-int dlog (int flag, const char * file, int line,  const char *fmt, ...)
+int dlog (int flag, char * file, int line,  const char *fmt, ...)
 {
   va_list     ap;
@@ -250,8 +231,8 @@
   if (flag == 1)
     {
-      sl_snprintf    (val, 81, _("\n---------  %10s "), file);
-      sl_strlcpy     (msg,    val,   sizeof(msg));
-      sl_snprintf    (val, 81, _(" --- %6d ---------\n"), line);
-      sl_strlcat     (msg,     val,   sizeof(msg));
+      sprintf        (val, _("\n---------  %10s "), file);
+      sl_strlcpy     (msg,    val,   80);
+      sprintf        (val, _(" --- %6d ---------\n"), line);
+      sl_strlcat     (msg,     val,   80);
       sh_log_console (msg);
     }
@@ -262,5 +243,5 @@
   else
     sl_strlcpy(tmp, fmt, 256);
-  retval = strlen(tmp);
+  retval = sl_strlen(tmp);
   if (retval > 0 && tmp[retval-1] == '\n')
     tmp[retval-1] = '\0';
@@ -277,5 +258,5 @@
       sprintf      (val, _("[%2d] "), trace_level);
       sl_strlcat   (msg,     val,   256);
-      sl_vsnprintf (&msg[strlen(msg)], 255, tmp, ap);
+      sl_vsnprintf (&msg[sl_strlen(msg)], 255, tmp, ap);
       sl_snprintf  (tmp, 255, _(" \t - File %c%s%c at line %d"), 
 		    0x22, file, 0x22, line);
@@ -581,38 +562,25 @@
   
 /*
- * Have memset in a different translation unit (i.e. this) to prevent 
- * it to get optimized away ...not safe with link-time optimisation...
- */
-void * sl_memset(void *s, int c, size_t n)
-{
-  /* See:
-   * https://www.usenix.org/sites/default/files/conference/protected-files/usenixsecurity17_slides_zhaomo_yang.pdf
-   */
-#if defined(HAVE_EXPLICIT_MEMSET)
-  return explicit_memset(s, c, n);
-#elif defined(HAVE_EXPLICIT_BZERO)
-  if (c == 0) {
-    explicit_bzero(s, n);
+ * A memset that does not get optimized away
+ */
+void *sl_memset(void *s, int c, size_t n)
+{
+  size_t i;
+  volatile char *p = s;
+
+  if (s == NULL || n <= 0)
     return s;
-  } else {
-    return memset(s, c, n);
-  }
-#elif defined(__GNUC__)
-  memset(s, c, n);
-  __asm__  __volatile__ ("" ::"r"(s): "memory"); /* compiler barrier */
+  
+  for (i = 0; i < n; ++i)
+    p[i] = (char) c;
   return s;
-#else
-  if (c == 0) {
-    size_t i;
-    volatile unsigned char * t_s = (volatile unsigned char *)s;
-    for (i=0; i<n; ++i)
-      t_s[i] = 0;
-    return s;
-  } else {
-    return memset(s, c, n);
-  }
-#endif  
-}
-
+}
+
+#if !defined(HOST_IS_I86SOLARIS)
+#if !defined (_GNU_SOURCE)
+extern int vsnprintf ( char *str, size_t n,
+		       const char *format, va_list ap );
+#endif
+#endif
 
 #if !defined (VA_COPY)
@@ -810,13 +778,12 @@
 
 #if defined(HAVE_VSNPRINTF) && !defined(HAVE_BROKEN_VSNPRINTF)
-  len = vsnprintf (str, n, format, vl);                /* flawfinder: ignore */
+  len = vsnprintf (str, n, format, vl);
   str[n-1] = '\0';
 #else
-  VA_COPY (vl2, vl);                     /* save the argument list           */
+  VA_COPY (vl2, vl);                   /* save the argument list           */
   total = sl_printf_count (format, vl);
-  len = (int) total;
+  len   = (int) total;
   if (total < n) 
     {
-      /* flawfinder: ignore */
       vsprintf (str, format, vl2);       /* program has checked that it fits */
       str[n-1] = '\0';
@@ -838,5 +805,5 @@
  * ENULL:  src || format == NULL
  * ERANGE: n out of range
- * ETRUNC: truncated (unimplemented)
+ * ETRUNC: truncated
  */
 int sl_snprintf(char *str, size_t n,
@@ -855,5 +822,4 @@
   va_start (vl, format);
 #if defined(HAVE_VSNPRINTF) && !defined(HAVE_BROKEN_VSNPRINTF)
-  /* flawfinder: ignore */
   vsnprintf (str, n, format, vl);
   str[n-1] = '\0';
@@ -863,5 +829,4 @@
   if (total < n) 
     {
-      /* flawfinder: ignore */
       vsprintf (str, format, vl2);     /* program has checked that it fits */
       str[n-1] = '\0';
@@ -898,33 +863,33 @@
   register const char * q;
 
-  if (!(dst == NULL || src == NULL || *src == '\0'))
-    {
-      if (siz > 0) 
-	{
-
-	  /* How much free space do we have ?
-	   */
-	  dst_end  = strlen(dst);
-	  dst_free = siz - dst_end - 1;
-	  
-	  p = &dst[dst_end];
-	  q = src;
-	  
-	  while (dst_free > 0 && *q != '\0')
-	    {
-	      *p++ = *q++;
-	      --dst_free;
-	    }
-	
-	  /* NULL terminate dst.
-	   */
-	  *p = '\0';
-	
-	  if (*q == '\0')
-	    return SL_ENONE;
-	  else
-	    return SL_ETRUNC;
-	}
-    }
+  if (dst == NULL)
+    return SL_ENONE;
+  if (src == NULL || src == "") 
+    return SL_ENONE;
+
+  if (siz > 0) {
+
+    /* How much free space do we have ?
+     */
+    dst_end  = strlen(dst);
+    dst_free = siz - dst_end - 1;
+
+    p = &dst[dst_end];
+    q = src;
+
+    while (dst_free > 0 && *q != '\0')
+      {
+	*p++ = *q++;
+	--dst_free;
+      }
+
+    /* NULL terminate dst.
+     */
+    *p = '\0';
+
+    if (*q != '\0') 
+      return SL_ETRUNC;
+  }
+
   return SL_ENONE;
 }
@@ -945,27 +910,24 @@
   /* SL_ENTER(_("sl_strlcpy")); */
 
-  if (!((dst == NULL) || (src == NULL))) 
-    {
-      if (siz > 0) {
-	/* copy siz-1 characters 
-	 */
-	(void) strncpy(dst, src, siz-1);
-
-	/* NULL terminate
-	 */
-	dst[siz-1] = '\0';
-      }
-      return SL_ENONE;
-    }
-  else if (src == NULL)
-    {
-      if (dst && siz > 0) 
+  if (dst == NULL)
+    return SL_ENULL;
+  if (src == NULL)
+    { 
+      if (siz > 0) 
 	dst[0] = '\0';
       return SL_ENONE;
     }
-  else
-    {
-      return SL_ENULL;
-    } 
+
+
+  if (siz > 0) {
+    /* copy siz-1 characters 
+     */
+    (void) strncpy(dst, src, siz-1);
+
+    /* NULL terminate
+     */
+    dst[siz-1] = '\0';
+  }
+  return SL_ENONE;
 }
 
@@ -1044,41 +1006,4 @@
 }
 
-#include <ctype.h>
-int sl_strcasecmp(const char * one, const char * two)
-{
-#ifdef SL_FAIL_ON_ERROR
-  SL_REQUIRE (one != NULL, _("one != NULL"));
-  SL_REQUIRE (two != NULL, _("two != NULL"));
-#endif
-
-  if (one && two)
-    {
-      do {
-	if (*one && *two)
-	  {
-	    if (tolower((int) *one) == tolower((int) *two))
-	      {
-		++one; ++two;
-	      }
-	    else if (tolower((int) *one) < tolower((int) *two))
-	      return -1;
-	    else
-	      return 1;
-	  }
-	else if (*one == '\0' && *two == '\0')
-	  return 0;
-	else if (*one == '\0')
-	  return -1;
-	else
-	  return 1;
-      } while (1 == 1);
-    }
-  else if (one == NULL && two != NULL)
-    return -1;
-  else if (one != NULL && two == NULL)
-    return 1;
-  else
-    return -7; /* default to not equal */
-}
 
 int sl_strcmp(const char * a, const char * b)
@@ -1096,39 +1021,5 @@
     return (1);
   else
-    return (-7); /* default to not equal */
-}
-
-/* Does not report sign. */
-int sl_ts_strncmp(const char * a, const char * b, size_t n)
-{
-#ifdef SL_FAIL_ON_ERROR
-  SL_REQUIRE (a != NULL, _("a != NULL"));
-  SL_REQUIRE (b != NULL, _("b != NULL"));
-  SL_REQUIRE (n > 0, _("n > 0"));
-#endif
-
-  if (a != NULL && b != NULL)
-    {
-      const unsigned char *a1 = (const unsigned char *)a;
-      const unsigned char *b1 = (const unsigned char *)b;
-      size_t i;
-      int  retval=0;
-      /* The simple index based access is optimized best by the
-       * compiler (tested with gcc 7.3.0). */
-      for (i = 0; i < n; ++i)
-	{
-	  if (a1[i] == '\0' || b1[i] == '\0')
-	    break;
-	  retval |= (a1[i] ^ b1[i]);
-	}
-      /* if (retval == 0) --> false (0) */ 
-      return (retval != 0);
-    }
-  else if (a == NULL && b != NULL)
-    return (-1);
-  else if (a != NULL && b == NULL)
-    return (1);
-  else
-    return (-7); /* default to not equal */
+    return (-7); /* arbitrary */
 }
 
@@ -1148,23 +1039,5 @@
     return (1);
   else
-    return (-7); /* default to not equal */
-}
-
-int sl_strncasecmp(const char * a, const char * b, size_t n)
-{
-#ifdef SL_FAIL_ON_ERROR
-  SL_REQUIRE (a != NULL, _("a != NULL"));
-  SL_REQUIRE (b != NULL, _("b != NULL"));
-  SL_REQUIRE (n > 0, _("n > 0"));
-#endif
-
-  if (a != NULL && b != NULL)
-    return (strncasecmp(a, b, n));
-  else if (a == NULL && b != NULL)
-    return (-1);
-  else if (a != NULL && b == NULL)
-    return (1);
-  else
-    return (-7); /* default to not equal */
+    return (-7); /* arbitrary */
 }
 
@@ -1175,5 +1048,5 @@
 {
 #ifndef HAVE_STRSTR
-  unsigned int    i;
+  int             i;
   size_t          needle_len;
   size_t          haystack_len;
@@ -1214,6 +1087,6 @@
 static   gid_t   rgid_orig;
 
-static   int     uids_are_stored = S_FALSE;
-static   int     suid_is_set     = S_TRUE;
+static   int     uids_are_stored = SL_FALSE;
+static   int     suid_is_set     = SL_TRUE;
 
 #ifdef HAVE_SETRESUID
@@ -1229,5 +1102,5 @@
 int sl_is_suid()
 {
-  if (uids_are_stored == S_FALSE)
+  if (uids_are_stored == SL_FALSE)
     {
       if (getuid() == geteuid() && getgid() == getegid())
@@ -1252,6 +1125,6 @@
 {
   SL_ENTER(_("sl_get_euid"));
-  /* SL_REQUIRE(uids_are_stored == S_TRUE, _("uids_are_stored == S_TRUE"));*/
-  if (uids_are_stored == S_TRUE)
+  /* SL_REQUIRE(uids_are_stored == SL_TRUE, _("uids_are_stored == SL_TRUE"));*/
+  if (uids_are_stored == SL_TRUE)
     *ret = euid;
   else
@@ -1262,6 +1135,6 @@
 uid_t sl_ret_euid()
 {
-  /* SL_REQUIRE(uids_are_stored == S_TRUE, _("uids_are_stored == S_TRUE"));*/
-  if (uids_are_stored == S_TRUE)
+  /* SL_REQUIRE(uids_are_stored == SL_TRUE, _("uids_are_stored == SL_TRUE"));*/
+  if (uids_are_stored == SL_TRUE)
     return (euid);
   else
@@ -1276,6 +1149,6 @@
 {
   SL_ENTER(_("sl_get_egid"));
-  /* SL_REQUIRE(uids_are_stored == S_TRUE, _("uids_are_stored == S_TRUE"));*/
-  if (uids_are_stored == S_TRUE)
+  /* SL_REQUIRE(uids_are_stored == SL_TRUE, _("uids_are_stored == SL_TRUE"));*/
+  if (uids_are_stored == SL_TRUE)
     *ret = egid;
   else
@@ -1291,6 +1164,6 @@
 {
   SL_ENTER(_("sl_get_ruid"));
-  /* SL_REQUIRE(uids_are_stored == S_TRUE, _("uids_are_stored == S_TRUE"));*/
-  if (uids_are_stored == S_TRUE)
+  /* SL_REQUIRE(uids_are_stored == SL_TRUE, _("uids_are_stored == SL_TRUE"));*/
+  if (uids_are_stored == SL_TRUE)
     *ret = ruid;
   else
@@ -1306,6 +1179,6 @@
 {
   SL_ENTER(_("sl_get_rgid"));
-  /* SL_REQUIRE(uids_are_stored == S_TRUE, _("uids_are_stored == S_TRUE"));*/
-  if (uids_are_stored == S_TRUE)
+  /* SL_REQUIRE(uids_are_stored == SL_TRUE, _("uids_are_stored == SL_TRUE"));*/
+  if (uids_are_stored == SL_TRUE)
     *ret = rgid;
   else
@@ -1321,6 +1194,6 @@
 {
   SL_ENTER(_("sl_get_ruid_orig"));
-  /* SL_REQUIRE(uids_are_stored == S_TRUE, _("uids_are_stored == S_TRUE"));*/
-  if (uids_are_stored == S_TRUE)
+  /* SL_REQUIRE(uids_are_stored == SL_TRUE, _("uids_are_stored == SL_TRUE"));*/
+  if (uids_are_stored == SL_TRUE)
     *ret = ruid_orig;
   else
@@ -1336,6 +1209,6 @@
 {
   SL_ENTER(_("sl_get_rgid_orig"));
-  /* SL_REQUIRE(uids_are_stored == S_TRUE, _("uids_are_stored == S_TRUE"));*/
-  if (uids_are_stored == S_TRUE)
+  /* SL_REQUIRE(uids_are_stored == SL_TRUE, _("uids_are_stored == SL_TRUE"));*/
+  if (uids_are_stored == SL_TRUE)
     *ret = rgid_orig;
   else
@@ -1362,17 +1235,17 @@
   SL_ENTER(_("sl_set_suid"));
 
-  if (uids_are_stored == S_FALSE)
+  if (uids_are_stored == SL_FALSE)
     {
       SL_IRETURN(SL_ENONE, _("sl_set_suid"));
     }
 
-  SL_REQUIRE(uids_are_stored == S_TRUE, _("uids_are_stored == S_TRUE"));  
+  SL_REQUIRE(uids_are_stored == SL_TRUE, _("uids_are_stored == SL_TRUE"));  
 
   if (ruid == euid && rgid == egid) 
     {
-      suid_is_set = S_TRUE;
+      suid_is_set = SL_TRUE;
       SL_IRETURN(SL_ENONE, _("sl_set_suid"));
     }  
-  SL_REQUIRE(suid_is_set     == S_FALSE, _("suid_is_set == S_FALSE"));  
+  SL_REQUIRE(suid_is_set     == SL_FALSE, _("suid_is_set == SL_FALSE"));  
 
 #if defined(HAVE_SETRESUID)
@@ -1403,5 +1276,5 @@
 
   SL_REQUIRE(retval == 0, _("retval == 0"));
-  suid_is_set = S_TRUE;
+  suid_is_set = SL_TRUE;
   SL_IRETURN(SL_ENONE, _("sl_set_suid"));
 }
@@ -1417,17 +1290,17 @@
   SL_ENTER(_("sl_unset_suid"));
 
-  if (uids_are_stored == S_FALSE)
+  if (uids_are_stored == SL_FALSE)
     {
       SL_IRETURN(SL_ENONE, _("sl_unset_suid"));
     }
 
-  SL_REQUIRE(uids_are_stored == S_TRUE, _("uids_are_stored == S_TRUE"));
+  SL_REQUIRE(uids_are_stored == SL_TRUE, _("uids_are_stored == SL_TRUE"));
 
   if (ruid == euid && rgid == egid)
     {
-      suid_is_set = S_FALSE;
+      suid_is_set = SL_FALSE;
       SL_IRETURN(SL_ENONE, _("sl_unset_suid"));
     }  
-  SL_REQUIRE(suid_is_set     == S_TRUE, _("suid_is_set == S_TRUE"));  
+  SL_REQUIRE(suid_is_set     == SL_TRUE, _("suid_is_set == SL_TRUE"));  
 
 #if defined(HAVE_SETRESUID)
@@ -1457,5 +1330,5 @@
 
   SL_REQUIRE(retval == 0, _("retval == 0"));
-  suid_is_set = S_FALSE;
+  suid_is_set = SL_FALSE;
   SL_IRETURN(SL_ENONE, _("sl_unset_suid"));
 }
@@ -1468,5 +1341,5 @@
 {
   SL_ENTER(_("sl_save_uids"));
-  if (uids_are_stored == S_TRUE) 
+  if (uids_are_stored == SL_TRUE) 
     SL_IRETURN(SL_EREPEAT, _("sl_save_uids"));
 
@@ -1477,5 +1350,5 @@
   ruid = ruid_orig;
   rgid = rgid_orig;
-  uids_are_stored = S_TRUE;
+  uids_are_stored = SL_TRUE;
 
   SL_IRETURN(SL_ENONE, _("sl_save_uids"));
@@ -1490,5 +1363,5 @@
 {
   SL_ENTER(_("sl_drop_privileges"));
-  SL_REQUIRE(uids_are_stored == S_TRUE, _("uids_are_stored == S_TRUE"));
+  SL_REQUIRE(uids_are_stored == SL_TRUE, _("uids_are_stored == SL_TRUE"));
 
   SL_REQUIRE(setgid(rgid_orig) == 0, _("setgid(rgid_orig) == 0"));
@@ -1515,5 +1388,5 @@
 {
   SL_ENTER(_("sl_policy_get_root"));
-  SL_REQUIRE(uids_are_stored == S_FALSE, _("uids_are_stored == S_FALSE"));
+  SL_REQUIRE(uids_are_stored == SL_FALSE, _("uids_are_stored == SL_FALSE"));
 
   SL_REQUIRE (sl_save_uids() == SL_ENONE, _("sl_save_uids() == SL_ENONE"));
@@ -1528,5 +1401,5 @@
       rgid = egid;
     }
-  suid_is_set = S_TRUE;
+  suid_is_set = SL_TRUE;
   if (euid == 0)
     {
@@ -1546,20 +1419,13 @@
 int sl_policy_get_real(char * user)
 {
+  struct passwd * tempres;
+
   SL_ENTER(_("sl_policy_get_real"));
-  SL_REQUIRE(uids_are_stored == S_FALSE, _("uids_are_stored == S_FALSE"));
+  SL_REQUIRE(uids_are_stored == SL_FALSE, _("uids_are_stored == SL_FALSE"));
   SL_REQUIRE (sl_save_uids() == SL_ENONE, _("sl_save_uids() == SL_ENONE"));
 
   if (euid == 0 || ruid == 0)
     {
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-      struct passwd    pwd;
-      char          *  buffer;
-      struct passwd *  tempres;
-      buffer = calloc(1,SH_PWBUF_SIZE);
-      SL_REQUIRE (buffer != NULL, _("buffer != NULL"));
-      sh_getpwnam_r(user, &pwd, buffer, SH_PWBUF_SIZE, &tempres);
-#else
-      struct passwd * tempres = sh_getpwnam(user);
-#endif
+      tempres = sh_getpwnam(user);
 
       SL_REQUIRE (NULL != tempres, _("tempres != NULL"));
@@ -1567,7 +1433,4 @@
       rgid_orig = tempres->pw_gid;
       ruid_orig = tempres->pw_uid;
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-      free(buffer);
-#endif
     }
   else
@@ -1580,5 +1443,5 @@
 	      _("sl_drop_privileges() == SL_ENONE"));
 
-  suid_is_set = S_TRUE;
+  suid_is_set = SL_TRUE;
   SL_IRETURN(SL_ENONE, _("sl_policy_get_real"));
 }
@@ -1590,35 +1453,29 @@
  * Do nothing if not SUID.
  */
-int sl_policy_get_user(const char * user)
-{
+int sl_policy_get_user(char * user)
+{
+  struct passwd * tempres;
+
   SL_ENTER(_("sl_policy_get_user"));
 
   SL_REQUIRE(user != NULL, _("user != NULL"));
-  SL_REQUIRE(uids_are_stored == S_FALSE, _("uids_are_stored == S_FALSE"));
+  SL_REQUIRE(uids_are_stored == SL_FALSE, _("uids_are_stored == SL_FALSE"));
   SL_REQUIRE (sl_save_uids() == SL_ENONE, _("sl_save_uids() == SL_ENONE"));
 
-#ifndef SH_ALLOW_SUID
   if (euid != ruid || egid != rgid)
     {
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-      struct passwd    pwd;
-      char          *  buffer;
-      struct passwd *  tempres;
-      buffer = calloc(1,SH_PWBUF_SIZE);
-      SL_REQUIRE (buffer != NULL, _("buffer != NULL"));
-      sh_getpwnam_r(user, &pwd, buffer, SH_PWBUF_SIZE, &tempres);
-#else
-      struct passwd * tempres = sh_getpwnam(user);
-#endif
+      tempres = sh_getpwnam(user);
 
       SL_REQUIRE (NULL != tempres, _("tempres != NULL"));
 
+#if 0
+      rgid = tempres->pw_gid;
+      ruid = tempres->pw_uid;
+      SL_REQUIRE(sl_unset_suid() == SL_ENONE, 
+		 _("sl_unset_suid() == SL_ENONE"));
+#endif
       SL_REQUIRE (sl_drop_privileges() == SL_ENONE,
 		  _("sl_drop_privileges() == SL_ENONE"));
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_GETPWNAM_R)
-      free(buffer);
-#endif
-    }
-#endif
+    }
   SL_IRETURN(SL_ENONE, _("sl_policy_get_user"));
 }
@@ -1640,77 +1497,13 @@
 
 typedef struct openfiles {
-  SL_TICKET ticket;          /* The unique  ID.      */ 
-  int fd;                    /* The file descriptor. */
-  FILE * stream;             /* The file descriptor. */
-  char * path;               /* The file path.       */
-  int flush;                 /* Whether we want to flush the cache */
-  char ofile[SL_OFILE_SIZE]; /* origin file */
-  int  oline;                /* origin line */
-  sh_string * content;       /* The file content     */
+  SL_TICKET ticket;     /* The unique  ID.      */ 
+  int fd;               /* The file descriptor. */
+  char * path;          /* The file path.       */
 } SL_OFILE; 
 
 static SL_OFILE * ofiles[MAXFD]; 
 
-static char stale_orig_file[64] = { '\0' };
-static int  stale_orig_line = -1;
-static char stale_orig_mesg[128];
-
-static char badfd_orig_file[64] = { '\0' };
-static int  badfd_orig_line = -1;
-static char badfd_orig_mesg[128];
-
-
-char * sl_check_stale()
-{
-  if (stale_orig_line == -1)
-    return NULL;
-  sl_snprintf(stale_orig_mesg, sizeof(stale_orig_mesg), 
-	      _("stale handle, %s, %d"), stale_orig_file, stale_orig_line);
-  stale_orig_file[0] = '\0';
-  stale_orig_line    = -1;
-  return stale_orig_mesg;
-}
-
-char * sl_check_badfd()
-{
-  if (badfd_orig_line == -1)
-    return NULL;
-  sl_snprintf(badfd_orig_mesg, sizeof(badfd_orig_mesg), 
-	      _("close on file descriptor with allocated handle, %s, %d"), 
-	      badfd_orig_file, badfd_orig_line);
-  badfd_orig_file[0] = '\0';
-  badfd_orig_line    = -1;
-  return badfd_orig_mesg;
-}
-
-typedef struct { volatile unsigned int atom; } atomic_t;
-static atomic_t nonce_counter = { TOFFSET };
-
-#if defined(__GNUC__) && (defined(__i486__) || defined(__x86_64__))
-/* from linux/include/asm-i386/atomic.h */
-static unsigned int atomic_add ( unsigned int i, atomic_t *var)
-{
-  unsigned int j = i;
-
-  __asm__ __volatile__ ("lock; xaddl %0, %1"
-			: "+r" (i), "+m" (var->atom)
-			: : "memory");
-  return j+i; 
-}
-#else
-SH_MUTEX_STATIC(mutex_ticket, PTHREAD_MUTEX_INITIALIZER);
-
-static unsigned int atomic_add ( unsigned int i, atomic_t *var)
-{
-  volatile unsigned int j;
-
-  SH_MUTEX_LOCK_UNSAFE(mutex_ticket);
-  var->atom += i;
-  j = var->atom;
-  SH_MUTEX_UNLOCK_UNSAFE(mutex_ticket);
-
-  return j;
-}
-#endif
+
+static unsigned int nonce_counter = TOFFSET;
 
 static
@@ -1719,14 +1512,9 @@
   unsigned int high; /* index */ 
   unsigned int low;  /* nonce */
-  SL_TICKET    retval = SL_EINTERNAL;
-  unsigned int nonce;/* nonce */
 
   SL_ENTER(_("sl_create_ticket"));
 
-  if (myindex >= MAXFD)
-    {
-      retval = SL_EINTERNAL01;
-      goto out_ticket;
-    }
+  if (myindex >= MAXFD) 
+    SL_IRETURN (SL_EINTERNAL, _("sl_create_ticket")); 
 
   /* mask out the high bit and check that it is not used
@@ -1735,35 +1523,21 @@
   high = (myindex + TOFFSET) & 0x7fff; 
 
-  if (high != myindex + TOFFSET)
-    {
-      retval = SL_EINTERNAL02;
-      goto out_ticket;
-    }
-
-  nonce = atomic_add(1, &nonce_counter);
-
+  if (high != myindex + TOFFSET) 
+    SL_IRETURN (SL_EINTERNAL, _("sl_create_ticket")); 
+
+  low = nonce_counter & 0xffff;
+
+  /* Overflow -> nonce too big.
+   */
+  if ((low != nonce_counter++) || low == 0)
+    SL_IRETURN (SL_EINTERNAL, _("sl_create_ticket"));
+ 
   /* Wrap around the nonce counter.
    * This is a dirty trick.
    */
-  if (nonce > 0x7fff)
-    {
-      nonce_counter.atom = TOFFSET;
-      nonce = atomic_add(1, &nonce_counter);
-    }
-
-  low = nonce & 0xffff;
-
-  /* Overflow -> nonce too big.
-   */
-  if ((low != nonce) || low == 0)
-    {
-      retval = SL_EINTERNAL03;
-      goto out_ticket;
-    }
-
-  retval = (SL_TICKET) ((high << 16) | low);
-
- out_ticket:
-  SL_RETURN (retval, _("sl_create_ticket")); 
+  if (nonce_counter > 0x7fff)
+    nonce_counter = TOFFSET;
+
+  SL_RETURN ((SL_TICKET) ((high << 16) | low), _("sl_create_ticket")); 
 }
 
@@ -1785,21 +1559,18 @@
 
   if ((of = ofiles[myindex])->fd < 0 || of->fd >= MAXFD )
-    return (SL_EINTERNAL04);
+    return (SL_EINTERNAL);
 
   if (((of->ticket) & 0xffff) == 0)
-    return (SL_EINTERNAL05); 
+    return (SL_EINTERNAL); 
 
   return (myindex); 
 }
 
-SL_TICKET sl_make_ticket (const char * ofile, int oline,
-			  int fd, const char * filename, FILE * stream)
-{
-  size_t    len;
+SL_TICKET sl_make_ticket (int fd, char * filename)
+{
   SL_TICKET ticket;
   SL_ENTER(_("sl_make_ticket"));
   /* Make entry.
    */
-  /* cppcheck-suppress arrayIndexOutOfBoundsCond */
   if (fd >= MAXFD || fd < 0)
      {
@@ -1807,29 +1578,18 @@
      }
 
-  if (ofiles[fd] != NULL) /* stale entry */
-    {
-      /* SL_IRETURN(SL_EINTERNAL06, _("sl_make_ticket")); */
-      sl_strlcpy(stale_orig_file, ofiles[fd]->ofile, sizeof(stale_orig_file));
-      stale_orig_line = ofiles[fd]->oline;
-
-      if (ofiles[fd]->content)
-	sh_string_destroy(&(ofiles[fd]->content));
-      (void) free (ofiles[fd]->path);
-      (void) free (ofiles[fd]);
+   if (ofiles[fd] != NULL)
+    {
+      SL_IRETURN(SL_EINTERNAL, _("sl_make_ticket"));
+    }
+
+  if ( (ofiles[fd] = (SL_OFILE *) malloc(sizeof(SL_OFILE))) == NULL)
+    {
+      SL_IRETURN(SL_EMEM, _("sl_make_ticket"));
+    }
+
+   if ( (ofiles[fd]->path = (char *) malloc( strlen(filename)+1) ) == NULL)
+    {
+      free(ofiles[fd]);
       ofiles[fd] = NULL;
-    }
-
-  if ( (ofiles[fd] = calloc(1,sizeof(SL_OFILE))) == NULL)
-    {
-      SL_IRETURN(SL_EMEM, _("sl_make_ticket"));
-    }
-
-  len = sl_strlen(filename)+1;
-
-  if ( (ofiles[fd]->path = calloc(1,len) ) == NULL)
-    {
-      free (ofiles[fd]);
-      ofiles[fd] = NULL;
-      /* cppcheck-suppress memleak */
       SL_IRETURN(SL_EMEM, _("sl_make_ticket"));
     }
@@ -1843,20 +1603,11 @@
       (void) free (ofiles[fd]->path);
       (void) free (ofiles[fd]);
-      ofiles[fd] = NULL;
-      /* cppcheck-suppress memleak */
       SL_IRETURN(ticket, _("sl_make_ticket"));
     }
 
-  sl_strlcpy (ofiles[fd]->path, filename, len);
-  ofiles[fd]->ticket  = ticket;
-  ofiles[fd]->fd      = fd;
-  ofiles[fd]->content = NULL;
-  ofiles[fd]->stream  = stream;
-  ofiles[fd]->flush   = S_FALSE;
-
-  sl_strlcpy(ofiles[fd]->ofile, ofile, SL_OFILE_SIZE);
-  ofiles[fd]->oline = oline;
-
-  /* cppcheck-suppress memleak */
+  strcpy (ofiles[fd]->path, filename);                    /* Known to fit  */
+  ofiles[fd]->ticket = ticket;
+  ofiles[fd]->fd     = fd;
+
   SL_IRETURN(ticket, _("sl_make_ticket"));
 }
@@ -1873,5 +1624,5 @@
 
 #if !defined(O_NOATIME)
-#if defined(__linux__) && (defined(__i386__) || defined(__x86_64__) || defined(__PPC__))
+#if defined(__linux__) && (defined(__i386__) || defined(__PPC__))
 #define O_NOATIME 01000000
 #else
@@ -1888,15 +1639,12 @@
 
 static
-int sl_open_file (const char * ofile, int oline,
-		  const char *filename, int mode, int priv)
+int sl_open_file (char *filename, int mode, int priv)
 {
   struct stat   lbuf;
   struct stat   buf;
-  int           errval = 0;
   int           lstat_return;
   int           stat_return;
   int           fd;
   int           sflags;
-  size_t        len;
   SL_TICKET     ticket;
  
@@ -1914,10 +1662,10 @@
     SL_IRETURN(SL_ENULL, _("sl_open_file"));
   if (mode < SL_OPEN_MIN || mode > SL_OPEN_MAX)
-    SL_IRETURN(SL_EINTERNAL07, _("sl_open_file"));
+    SL_IRETURN(SL_EINTERNAL, _("sl_open_file"));
     
   /* "This system call always succeeds and the previous value of
    * the mask is returned." 
    */
-  (void) umask (0);
+  (void) umask (0); 
 
   if (mode == SL_OPEN_FOR_FASTREAD)
@@ -1925,10 +1673,8 @@
       fd = aud_open_noatime (FIL__, __LINE__, priv, filename, 
 			     O_RDONLY|O_NONBLOCK, 0, &o_noatime);
-      /*
       if (fd >= 0) {
 	sflags = retry_fcntl(FIL__, __LINE__, fd, F_GETFL, 0);
 	retry_fcntl(FIL__, __LINE__, fd, F_SETFL, sflags & ~O_NONBLOCK);
       }
-      */
       if (fd < 0)
 	SL_IRETURN(SL_EBADFILE, _("sl_open_file"));
@@ -1944,5 +1690,4 @@
   else
     lstat_return = retry_lstat(FIL__, __LINE__, filename, &lbuf);
-  errval = errno;
 #ifdef USE_SUID
   if (priv == SL_YESPRIV)
@@ -1954,10 +1699,9 @@
       lstat_return = ENOENT;
       if ( (mode == SL_OPEN_FOR_READ && lstat_return == ENOENT) ||
-	   (errval != ENOENT))
+	   (errno != ENOENT))
 	{
 	  TPT(( 0, FIL__, __LINE__, _("msg=<lstat: %s> errno=<%d>\n"), 
-	    filename, errval));
-	  errno = errval;
-	  SL_IRETURN(SL_ESTAT, _("sl_open_file"));
+	    filename, errno));
+	  SL_IRETURN(SL_EBADFILE, _("sl_open_file"));
 	}
     }
@@ -1966,9 +1710,6 @@
        ( S_ISDIR(lbuf.st_mode) || (S_IWOTH & lbuf.st_mode) ) 
       )
-    {
-      int retval = S_ISDIR(lbuf.st_mode) ? SL_EISDIR : SL_EBADOTH;
-      errno = 0;
-      SL_IRETURN(retval, _("sl_open_file"));
-    }
+    SL_IRETURN(SL_EBADFILE, _("sl_open_file"));
+
     
   /* O_NOATIME has an effect for read(). But write() ?.
@@ -1979,5 +1720,4 @@
       fd = aud_open_noatime (FIL__, __LINE__, priv, filename, 
 			     O_RDONLY|O_NONBLOCK, 0, &o_noatime);
-      errval = errno;
       if (fd >= 0) {
 	sflags = retry_fcntl(FIL__, __LINE__, fd, F_GETFL, 0);
@@ -1992,27 +1732,19 @@
 	fd = aud_open (FIL__, __LINE__, priv, filename, 
 		       O_WRONLY,                   open_mode);
-      errval = errno;
       break;
     case SL_OPEN_SAFE_RDWR:
       if (lstat_return == ENOENT)
-	{
-	  fd = aud_open (FIL__, __LINE__, priv, filename, 
-			 O_RDWR|O_CREAT|O_EXCL,      open_mode);
-	  errval = errno;
-	}
+      	fd = aud_open (FIL__, __LINE__, priv, filename, 
+		       O_RDWR|O_CREAT|O_EXCL,      open_mode);
       else
-	{
-	  errno = errval;
-	  SL_IRETURN(SL_EBADFILE, _("sl_open_file"));
-	}
+	SL_IRETURN(SL_EBADFILE, _("sl_open_file"));
       break;
     case SL_OPEN_FOR_RDWR:
       if (lstat_return == ENOENT)
-	fd = aud_open (FIL__, __LINE__, priv, filename, 
-			 O_RDWR|O_CREAT|O_EXCL,      open_mode);
+      	fd = aud_open (FIL__, __LINE__, priv, filename, 
+		       O_RDWR|O_CREAT|O_EXCL,      open_mode);
       else
 	fd = aud_open (FIL__, __LINE__, priv, filename, 
 		       O_RDWR,                     open_mode);
-      errval = errno;
       break;
     case SL_OPEN_FOR_WTRUNC:
@@ -2023,5 +1755,4 @@
 	fd = aud_open (FIL__, __LINE__, priv, filename, 
 		       O_WRONLY|O_TRUNC,           open_mode);
-      errval = errno;
       break;
     case SL_OPEN_FOR_RWTRUNC:
@@ -2032,9 +1763,7 @@
 	fd = aud_open (FIL__, __LINE__, priv, filename, 
 		       O_RDWR|O_TRUNC,             open_mode);
-      errval = errno;
       break;
     default:
-      errno = 0;
-      SL_IRETURN(SL_EINTERNAL08, _("sl_open_file"));
+      SL_IRETURN(SL_EINTERNAL, _("sl_open_file"));
     }
 
@@ -2042,6 +1771,5 @@
     {
       TPT(( 0, FIL__, __LINE__, _("msg=<Error opening: %s> errno=<%d>\n"), 
-	    filename, errval));
-      errno = errval;
+	    filename, errno));
       SL_IRETURN(SL_EBADFILE, _("sl_open_file"));
     }
@@ -2052,5 +1780,4 @@
 #endif
   stat_return = retry_fstat(FIL__, __LINE__, fd, &buf);
-  errval = errno;
 #ifdef USE_SUID
   if (priv == SL_YESPRIV)
@@ -2060,14 +1787,11 @@
   if (stat_return < 0)
     {
-      sl_close_fd (FIL__, __LINE__, fd);
-      errno = errval;
-      SL_IRETURN(SL_EFSTAT, _("sl_open_file"));
-    }
-
-  errno = 0;
+      close (fd);
+      SL_IRETURN(SL_EBADFILE, _("sl_open_file"));
+    }
 
   if (lstat_return != ENOENT && buf.st_ino != lbuf.st_ino)
     {
-      sl_close_fd (FIL__, __LINE__, fd);
+      close (fd);
       SL_IRETURN(SL_EBOGUS, _("sl_open_file"));
     }
